// IBox.H - include file for IBox simulation

#ifndef IBOX_H
#define IBOX_H

class IBox {
private:
  Icache IC;
  BTB TheBTB;

public:
  IBox(aint_addr_t init_pc) { PC = init_pc; }

  aint_addr_t Fetch(); // Return the pc for current fetch so backend can use it to do AINT_fetch
  void Update(aint_addr_t real_target);



#endif
