#ifndef AINT_SYSCALL_H
#define AINT_SYSCALL_H

/* Aint "syscall" number definitions. */
#define AINT_PTHREAD_SYSCALL_BASE  0x42000000
#define SYS_aint_pthread_create (AINT_PTHREAD_SYSCALL_BASE + 1)
#define SYS_aint_pthread_join   (AINT_PTHREAD_SYSCALL_BASE + 2)
#define SYS_aint_pthread_exit   (AINT_PTHREAD_SYSCALL_BASE + 3)
#define SYS_aint_pthread_key_create (AINT_PTHREAD_SYSCALL_BASE + 4)
#define SYS_aint_pthread_keycreate SYS_aint_pthread_key_create

#define SYS_aint_pthread_setspecific (AINT_PTHREAD_SYSCALL_BASE + 5)
#define SYS_aint_pthread_getspecific (AINT_PTHREAD_SYSCALL_BASE + 6)

#define SYS_aint_pthread_self   (AINT_PTHREAD_SYSCALL_BASE + 7)

#endif
