void
alpha_lock(int* addr)
{
  int *x;
  asm("_again: ldl_l %0 %1; xor %0 %0 %0; stl_c %0 %1; beq %0, _again" :
      "=r" (x), "=o"(*addr));
}

void
alpha_atomic_add(int* addr, int value)
{
  int *x;
  /* Do an atomic update */
  asm("_again2: ldl_l %0 %1; addl %0 %2 %0; stl_c %0 %1; beq %0, _again2":
	"&=r" (x), "=o"(*addr): "r"(value));
}

void
alpha_atomic_add_q(long* addr, long value)
{
  long *x;
  /* Do an atomic update */
  asm("_again3: ldq_l %0 %1; addq %0 %2 %0; stq_c %0 %1; beq %0, _again3":
	"&=r" (x), "=o"(*addr): "r"(value));
}

void
alpha_mb()
{
  asm("mb");
}
