#ifndef AINT_IPC_H
#define AINT_IPC_H
/*
 * Structure definitions for supporting System V semaphores and
 * shared memory.
 */

#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#ifdef 0
struct sysv_semid_ds {
    struct ipc_perm sem_perm;
    struct sysv_sem *sem_base;
    ushort sem_nsems;
    aint_time_t sem_otime;
    aint_time_t sem_ctime;
    int inuse;
};

struct sysv_sem {
    ushort semval;
    short sempid;
    short semncnt;
    short semzcnt;
    qnode_t nwait_q;
    qnode_t zwait_q;
};

#endif

struct sysv_shm {
  struct ipc_perm shm_perm;
  void *paddr; /* address of mmap()'d segment to for this shm */
  unsigned long *fe_vector;  /* Full empty bits - used with the load_s and store_s operations */
  int inuse;
  /* ushort real_seg;  true if a system V segment was allocated */
  int size;
};

#define MAX_SEMASET 1024
#define MAX_SHMSEG   256

extern struct sysv_shm Shmseg[MAX_SHMSEG];

// struct  sysv_semid_ds;
// extern icode_ptr aint_semget(inflight_inst_ptr, icode_ptr, path_ptr, thread_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
// extern void semcpin(struct sysv_semid_ds *  , struct sysv_semid_ds * );
// extern void semcpout(struct sysv_semid_ds *  , struct sysv_semid_ds * );
// extern icode_ptr aint_semop(inflight_inst_ptr, icode_ptr, path_ptr, thread_ptr);
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
// extern icode_ptr aint_semctl(inflight_inst_ptr,  icode_ptr  , path_ptr, thread_ptr );
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
/* shmseg_allocate does the work for aint_shmget() */
extern int shmseg_allocate (long key, long size, long flags, long *errno);
extern icode_ptr aint_shmget(inflight_inst_ptr, icode_ptr  , path_ptr, thread_ptr );
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern int is_valid(long );
/* shmseg_attach() does the work for aint_shmat() */
ulong shmseg_attach(process_ptr process, int shmid, ulong addr, ulong flags, ulong *perrno);
extern icode_ptr aint_shmat(inflight_inst_ptr, icode_ptr  , path_ptr, thread_ptr );
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern icode_ptr aint_shmdt(inflight_inst_ptr, icode_ptr  , path_ptr, thread_ptr );
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
extern icode_ptr aint_shmctl(inflight_inst_ptr, icode_ptr  , path_ptr, thread_ptr );
		/* Prototype include a typedef name.
		   It should be moved after the typedef declaration */
#endif
