#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <syscall.h>

/* #include <aint_pthread.h> */
#include <errno.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>

#include <sys/resource.h>
#include <sys/time.h>

#include <sys/sysinfo.h>
#include <alpha/hal_sysinfo.h>
#include <alpha/fpu.h>
#include <sys/ioctl.h>
#include <sys/uswitch.h>
#include <sys/mount.h>
#include <dirent.h>
#include <sys/mman.h>

#include "aint_types.h"
#include "aint.h"
#include "ipc.h"

#include "sim.h"

#include "aint_syscall.h"


#include "globals.h"
#include "opcodes.h"
#include "subst.h"
#include "protos.h"

#define INSERT_F() {\
  struct icode pcopy; memcpy(&pcopy, picode, sizeof(struct icode)); \
  picode->next = pcopy; \
}

OP(aint_exit);
OP(aint_fork);
OP(aint_read);
OP(aint_write);
OP(aint_old_open);
OP(aint_close);
OP(aint_wait4);
OP(aint_old_creat);
OP(aint_link);
OP(aint_unlink);
OP(aint_execv);
OP(aint_chdir);
OP(aint_fchdir);
OP(aint_mknod);
OP(aint_chmod);
OP(aint_chown);
OP(aint_obreak);
OP(aint_getfsstat);
OP(aint_lseek);
OP(aint_getpid);
OP(aint_mount);
OP(aint_unmount);
OP(aint_setuid);
OP(aint_getuid);
OP(aint_exec_with_loader);
OP(aint_ptrace);
#ifdef	COMPAT_43
#error ??
OP(aint_nrecvmsg);
OP(aint_nsendmsg);
OP(aint_nrecvfrom);
OP(aint_naccept);
OP(aint_ngetpeername);
OP(aint_ngetsockname);
#else
OP(aint_recvmsg);
OP(aint_sendmsg);
OP(aint_recvfrom);
OP(aint_accept);
OP(aint_getpeername);
OP(aint_getsockname);
#endif
OP(aint_access);
OP(aint_chflags);
OP(aint_fchflags);
OP(aint_sync);
OP(aint_kill);
OP(aint_old_stat);
OP(aint_setpgid);
OP(aint_old_lstat);
OP(aint_dup);
OP(aint_pipe);
OP(aint_set_program_attributes);
OP(aint_profil);
OP(aint_open);
				/* 46 is obsolete osigaction */
OP(aint_getgid);
OP(aint_sigprocmask);
OP(aint_getlogin);
OP(aint_setlogin);
OP(aint_acct);
OP(aint_sigpending);
OP(aint_ioctl);
OP(aint_reboot);
OP(aint_revoke);
OP(aint_symlink);
OP(aint_readlink);
OP(aint_execve);
OP(aint_umask);
OP(aint_chroot);
OP(aint_old_fstat);
OP(aint_getpgrp);
OP(aint_getpagesize);
OP(aint_mremap);
OP(aint_vfork);
OP(aint_stat);
OP(aint_lstat);
OP(aint_sbrk);
OP(aint_sstk);
OP(aint_mmap);
OP(aint_ovadvise);
OP(aint_munmap);
OP(aint_mprotect);
OP(aint_madvise);
OP(aint_old_vhangup);
OP(aint_kmodcall);
OP(aint_mincore);
OP(aint_getgroups);
OP(aint_setgroups);
OP(aint_old_getpgrp);
OP(aint_setpgrp);
OP(aint_setitimer);
OP(aint_old_wait);
OP(aint_table);
OP(aint_getitimer);
OP(aint_gethostname);
OP(aint_sethostname);
OP(aint_getdtablesize);
OP(aint_dup2);
OP(aint_fstat);
OP(aint_fcntl);
OP(aint_select);
OP(aint_poll);
OP(aint_fsync);
OP(aint_setpriority);
OP(aint_socket);
OP(aint_connect);
#ifdef	COMPAT_43
OP(aint_accept);
#else
OP(aint_old_accept);
#endif
OP(aint_getpriority);
#ifdef	COMPAT_43
OP(aint_send);
OP(aint_recv);
#else
OP(aint_old_send);
OP(aint_old_recv);
#endif
OP(aint_sigreturn);
OP(aint_bind);
OP(aint_setsockopt);
OP(aint_listen);
OP(aint_plock);
OP(aint_old_sigvec);
OP(aint_old_sigblock);
OP(aint_old_sigsetmask);
OP(aint_sigsuspend);
OP(aint_sigstack);
#ifdef	COMPAT_43
OP(aint_recvmsg);
OP(aint_sendmsg);
#else
OP(aint_old_recvmsg);
OP(aint_old_sendmsg);
#endif
				/* 115 is obsolete vtrace */
OP(aint_gettimeofday);
OP(aint_getrusage);
OP(aint_getsockopt);
OP(aint_readv);
OP(aint_writev);
OP(aint_settimeofday);
OP(aint_fchown);
OP(aint_fchmod);
#ifdef	COMPAT_43
OP(aint_recvfrom);
#else
OP(aint_old_recvfrom);
#endif
OP(aint_setreuid);
OP(aint_setregid);
OP(aint_rename);
OP(aint_truncate);
OP(aint_ftruncate);
OP(aint_flock);
OP(aint_setgid);
OP(aint_sendto);
OP(aint_shutdown);
OP(aint_socketpair);
OP(aint_mkdir);
OP(aint_rmdir);
OP(aint_utimes);
				/* 139 is obsolete 4.2 sigreturn */
OP(aint_adjtime);
#ifdef	COMPAT_43
OP(aint_getpeername);
#else
OP(aint_old_getpeername);
#endif
OP(aint_gethostid);
OP(aint_sethostid);
OP(aint_getrlimit);
OP(aint_setrlimit);
OP(aint_old_killpg);
OP(aint_setsid);
OP(aint_quotactl);
OP(aint_oldquota);
#ifdef	COMPAT_43
OP(aint_getsockname);
#else
OP(aint_old_getsockname);
#endif
OP(aint_pid_block);
OP(aint_pid_unblock);
OP(aint_sigaction);
OP(aint_sigwaitprim);
OP(aint_nfssvc);
OP(aint_getdirentries);
OP(aint_statfs);
OP(aint_fstatfs);
OP(aint_async_daemon);
OP(aint_getfh);
OP(aint_getdomainname);
OP(aint_setdomainname);
OP(aint_exportfs);
OP(aint_alt_plock);
OP(aint_getmnt);
OP(aint_alt_sigpending);
OP(aint_alt_setsid);
OP(aint_swapon);
OP(aint_msgctl);
OP(aint_msgget);
OP(aint_msgrcv);
OP(aint_msgsnd);
OP(aint_semctl);
OP(aint_semget);
OP(aint_semop);
OP(aint_uname);
OP(aint_lchown);
OP(aint_shmat);
OP(aint_shmctl);
OP(aint_shmdt);
OP(aint_shmget);
OP(aint_mvalid);
OP(aint_getaddressconf);
OP(aint_msleep);
OP(aint_mwakeup);
OP(aint_msync);
OP(aint_signal);
OP(aint_utc_gettime);
OP(aint_utc_adjtime);
OP(aint_security);
OP(aint_kloadcall);
OP(aint_getpgid);
OP(aint_getsid);
OP(aint_sigaltstack);
OP(aint_waitid);
OP(aint_priocntlset);
OP(aint_sigsendset);
OP(aint_set_speculative);
OP(aint_msfs_syscall);
OP(aint_sysinfo);
OP(aint_uadmin);
OP(aint_fuser);
OP(aint_proplist_syscall);
OP(aint_uswitch);
OP(aint_usleep_thread);
OP(aint_audcntl);
OP(aint_audgen);
OP(aint_sysfs);
OP(aint_subsys_info);
OP(aint_getsysinfo);
OP(aint_setsysinfo);
OP(aint_afs_syscall);
OP(aint_swapctl);
OP(aint_memcntl);

OP(aint_pthread_create);
OP(aint_pthread_join);
OP(aint_pthread_exit);
OP(aint_pthread_keycreate);
OP(aint_pthread_setspecific);
OP(aint_pthread_getspecific);
OP(aint_pthread_self);



typedef struct textregion_s {
  ulong startaddr;
  ulong len;
} textregion_t;

textregion_t textregion[MAX_NPROCS][MAX_FDNUM];


/* Intended to initialize any structs needed for syscall emulation */
void
subst_init()
{
}



/* The substitute functions are called from within the callsys_f function.
 */

/* This needs to be modified to call substitute functions through a pointer
 * rather than a switch statement */
#define finformative(_foo_) cout << _foo_
OP(callsys_f)
{
  icode_ptr ret_addr;

  /* Reset the process's lock_flag if set */
  pthread->lock_flag = 0;

    informative("[p" << pthread->pprocess->pid
	      << ".t" << pthread->tid
	      << "] CallSYS: " << MapReg(0)
	      << ":" << syscall_name(MapReg(0))
	      << " [" << (void *) MapReg(A0)
	      << " " << (void *) MapReg(A1)
	      << "]" << endl);

  switch (MapReg(0)) {

#define SYSCASE(n_) case SYS_ ## n_: ret_addr = aint_ ## n_ (ifi, picode, ppath, pthread); break;
    
  SYSCASE(exit);
  SYSCASE(fork);
  SYSCASE(read);
  SYSCASE(write);
  SYSCASE(close);
  SYSCASE(wait4);
  SYSCASE(link);
  SYSCASE(unlink);
  SYSCASE(chdir);
  SYSCASE(fchdir);
  SYSCASE(mknod);
  SYSCASE(chmod);
  SYSCASE(chown);

  case SYS_obreak:
    ret_addr = aint_brk(ifi, picode, ppath, pthread);
    break;

  SYSCASE(lseek);
  SYSCASE(getpid);
  SYSCASE(setuid);
  SYSCASE(getuid);
  SYSCASE(dup);

  SYSCASE(open);
  SYSCASE(getgid);
  SYSCASE(sigprocmask);
  SYSCASE(ioctl);
  
  SYSCASE(symlink);
  SYSCASE(readlink);
  SYSCASE(umask);
  SYSCASE(getpagesize);
  SYSCASE(stat);
  SYSCASE(lstat);

  SYSCASE(mmap);
  SYSCASE(munmap);

  SYSCASE(madvise);

  SYSCASE(fstat);
  SYSCASE(fcntl);
  SYSCASE(truncate);
  SYSCASE(ftruncate);

  /* jamey: continue implementing syscalls here */

  case SYS_gettimeofday:
    ret_addr = aint_gettimeofday(ifi, picode, ppath, pthread);
    break;

  SYSCASE(setrlimit);
  SYSCASE(getrlimit);
  SYSCASE(sigaction);

  SYSCASE(getdirentries);
  SYSCASE(statfs);
  SYSCASE(fstatfs);

  case SYS_shmget:
    ret_addr = aint_shmget(ifi, picode, ppath, pthread);
    break;

  case SYS_shmat:
    ret_addr = aint_shmat(ifi, picode, ppath, pthread);
    break;
  
  case SYS_shmdt:
    ret_addr = aint_shmdt(ifi, picode, ppath, pthread);
    break;
  
  case SYS_shmctl:
    ret_addr = aint_shmctl(ifi, picode, ppath, pthread);
    break;

  case SYS_getdtablesize:
    ret_addr = aint_getdtablesize(ifi, picode, ppath, pthread);
    break;

  case SYS_getrusage:
    ret_addr = aint_getrusage(ifi, picode, ppath, pthread);
    break;

  SYSCASE(uswitch);
  SYSCASE(usleep_thread);

  SYSCASE(set_speculative);

  SYSCASE(getsysinfo);
  SYSCASE(setsysinfo);

  SYSCASE(access);

  case SYS_aint_pthread_create:
      ret_addr = aint_pthread_create(ifi, picode, ppath, pthread);
      break;

  case SYS_aint_pthread_join:
      ret_addr = aint_pthread_join(ifi, picode, ppath, pthread);
      break;

  case SYS_aint_pthread_exit:
      ret_addr = aint_pthread_exit(ifi, picode, ppath, pthread);
      break;

  case SYS_aint_pthread_keycreate:
    ret_addr = aint_pthread_keycreate(ifi, picode, ppath, pthread);
    break;

  case SYS_aint_pthread_setspecific:
    ret_addr = aint_pthread_setspecific(ifi, picode, ppath, pthread);
    break;

  case SYS_aint_pthread_getspecific:
    ret_addr = aint_pthread_getspecific(ifi, picode, ppath, pthread);
    break;

  case SYS_aint_pthread_self:
    ret_addr = aint_pthread_self(ifi, picode, ppath, pthread);
    break;

  default:
    fatal("Unimplemented syscall " << MapReg(0) << ":" << syscall_name(MapReg(0)));
    ret_addr = picode->next;
    break;
  }

  informative("[p" << pthread->pprocess->pid
	      << ".t" << pthread->tid
	      << "] \t\t=> " << (void *) MapReg(RET_VAL_REG)
	      << " " << (void *) MapReg(ERRNO_REG) << endl);

  return ret_addr;
}

#define UPDATE_ERRNO() (MapReg(ERRNO_REG) = (MapReg(RET_VAL_REG) ? errno : 0))


/* this is *very* different from the original aint function.
 * since simulation is driven by pm, we don't need to go
 * through the scheduler
 */
OP(aint_exit)
{
  /* event_exit(pthread);  Calls task_exit calls sim_exit */
  pthread->exitcode = MapReg(A0);
  if (Verbose) fprintf(stderr, "Thread %d.%d exited with code %d\n", 
	      pthread->pprocess->pid,
	      pthread->tid,
	      (int) MapReg(A0));

  /* return &Iterminator1; Causes terminator1 to be called: */

  /* From terminator1: calls event_yield calls task_yield. Passes to terminate_thr: */

  /* terminate_thr calls event_terminate calls task_terminate; cleans up pending tasks - not reqd */
  /* Passes to terminator 2: */

  /* Need to wait for children: Not necessary since we're gonna die after anyway */

  /* Kill all threads?  Assuming this is the only thread for now */
  ifi->runstate = pthread->runstate = R_DONE;

  /* Unblock waiting threads in waiting processes. Need list of waiting processes & threads */


  sim_thread_end(pthread->tid);

  return NULL;
}

OP(aint_fork)
{
    int i;
    thread_ptr childt;
    process_ptr childp;
    int pid, tid;

    /* allocate a new process and thread */
    childp = new process(pthread->pprocess, pthread);
    childt = childp->threads;    // New process has only one thread

    /* copy the parent's address space to the child */
    // copy_addr_space(pthread, child);


    /* init_thread() must be called *after* copy_addr_space() since
     * init_thread() uses the mapping fields set up by copy_addr_space().
     */
    // init_process(childp);
    // init_thread(child, pevent);

    /* the first instruction for the child is to return */
    childt->picode = picode->next;

    /* the return value for the parent is the child's pid */
    MapReg(RET_VAL_REG) = pid;
    MapReg(ERRNO_REG) = 0;

    /* the return value for the child is 0 */
    childt->path_tree->pMapReg(RET_VAL_REG) = 0;
    childt->path_tree->pMapReg(ERRNO_REG) = 0;

    /* Set child flags - r20 is 0 for parent and 1 for child */
    MapReg(CHILD_FLAG_REG) = 0;
    childt->path_tree->pMapReg(CHILD_FLAG_REG) = 1;

    /* copy the parent's signal handler vectors - do this in process::process() */
    /* 
    for (i = 0; i < MAX_SIGNALS; i++) {
        childp->sigv[i].sv_handler = pthread->pprocess->sigv[i].sv_handler;
        childp->sigv[i].sv_mask = pthread->pprocess->sigv[i].sv_mask;
        childp->sigv[i].sv_flags = pthread->pprocess->sigv[i].sv_flags;
	}
    child->sigblocked = pthread->sigblocked;
    */

    // This tells the simulator about the new thread and its pc
    sim_thread_begin(childt->tid, childt->picode->addr);

    return picode->next;

}

OP(aint_read)
{

  process_ptr pprocess = pthread->pprocess;
  int pfd, vfd;
  unsigned char *mybuf = (unsigned char *) malloc(MapReg(A2) + 1);

  vfd = MapReg(A0);
  pfd = pthread->pprocess->fd[vfd];
  /* printf("aint_read: reading %d bytes from fd %d\n", MapReg(A2), MapReg(A0)); */

  MapReg(RET_VAL_REG) = read(pfd, mybuf, MapReg(A2));

  pprocess->memcpy_to_object_space(MapReg(A1), mybuf, MapReg(RET_VAL_REG));

  MapReg(ERRNO_REG) = 0;

  free((void *) mybuf);

  return picode->next;
} 

OP(aint_write)
{
  process_ptr pprocess = pthread->pprocess;
  int vfd, pfd;

  unsigned char *mybuf = (unsigned char *) malloc(MapReg(A2)+1);

  vfd = MapReg(A0);
  pfd = pthread->pprocess->fd[vfd];

  pprocess->memcpy_from_object_space(mybuf, MapReg(A1), MapReg(A2));

  MapReg(RET_VAL_REG) = write(pfd,
			  (caddr_t) mybuf,
			  MapReg(A2));
  MapReg(ERRNO_REG) = 0;
  free((void *) mybuf);
  return picode->next;
}

OP(aint_close)
{
  int vfd, pfd;
  process_ptr pprocess = pthread->pprocess;

  vfd = MapReg(A0);
  pfd = pprocess->fd[vfd];

    /* printf("aint_close: closing %d\n", MapReg(A0)); */
  if (pfd < 3) 
    MapReg(RET_VAL_REG) = 0;
  else
    MapReg(RET_VAL_REG) = close(pfd);

  pprocess->fd[vfd] = -1;


  // Crude hack - decode when /sbin/loader calls close
  if (textregion[pprocess->pid][vfd].startaddr != 0) {
    pprocess->decode_text_region(textregion[pprocess->pid][vfd].startaddr, 
				 textregion[pprocess->pid][vfd].len);
    textregion[pprocess->pid][vfd].startaddr = 0;
  }

  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_wait4)
{
  /* 
  process_ptr pprocess = pthread->pprocess;
  pid_t pid;
  int *status_location = NULL;
  int options;
  struct rusage *resource_usage = NULL;
  int childpid;
  long flags;
  */

  return picode->next;

#ifdef FIXME
  pid = MapReg(A0);
  if (MapReg(A1))
    status_location = (int *) pprocess->addr2phys(MapReg(A1), &flags);
  if ((flags & (PROT_READ|PROT_WRITE)) != (PROT_READ|PROT_WRITE)) {
    MapReg(ERRNO_REG) = EINVAL;
    MapReg(RET_VAL_REG) = -1;
    return picode->next;
  }
    
  options = MapReg(A2);
  if (MapReg(A3) != 0) {
    resource_usage = (struct rusage *) (long)pprocess->addr2phys(MapReg(A3), &flags);
    if ((flags & (PROT_READ|PROT_WRITE)) != (PROT_READ|PROT_WRITE)) {
      MapReg(ERRNO_REG) = EINVAL;
      MapReg(RET_VAL_REG) = -1;
      return picode->next;
    }
  }

  if ((pid == -1) && (options == 0)) {
    /* This is the msaint wait4. There is no scheduler. 
     *  The blocking sequence has to be changed */
    childpid = wait_for_child(pthread);
    if (childpid == 0) {
      event_block(pthread, E_WAIT);
      sleep_thr(pthread);
      pthread->runstate = R_WAIT;
      pthread->pprocess->runstate = R_WAIT;
      return picode;
    }
    MapReg(RET_VAL_REG) = childpid;
    if (childpid == -1)
      MapReg(ERRNO_REG) = ECHILD;
    else if (status_location)
	*status_location = 0;
    return picode->next;
  } else {
    fatal("aint_wait4(): unimplemented option " << options << endl);
  }
  /* we never get here */
  fatal("Reached verboten land in aint_wait4!");

#endif

}

OP(aint_link)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  char *path2 = pprocess->strdup_from_object_space(MapReg(A1));
  MapReg(RET_VAL_REG) = link(path1, path2);

  UPDATE_ERRNO();
  free(path1);
  free(path2);
  return picode->next;
}


OP(aint_unlink)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  MapReg(RET_VAL_REG) = unlink(path1);

  UPDATE_ERRNO();
  free(path1);
  return picode->next;
}

OP(aint_execv);
OP(aint_chdir)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  MapReg(RET_VAL_REG) = chdir(path1);

  UPDATE_ERRNO();
  free(path1);
  return picode->next;
}

OP(aint_fchdir)
{
#ifdef FIXME
  extern int fchdir(int);
  MapReg(RET_VAL_REG) = fchdir(MapReg(A0));
  UPDATE_ERRNO();
#endif
  return picode->next;
}

OP(aint_mknod)
{
#ifdef FIXME
  extern int mknod (const char *path, int mode, dev_t	device );

  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  MapReg(RET_VAL_REG) = mknod(path1, MapReg(A1), MapReg(A2));

  UPDATE_ERRNO();
  free(path1);
#endif
  return picode->next;
}

OP(aint_chmod)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  MapReg(RET_VAL_REG) = chmod(path1, MapReg(A1));

  UPDATE_ERRNO();
  free(path1);
  return picode->next;
}

OP(aint_chown)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  MapReg(RET_VAL_REG) = chown(path1, MapReg(A1), MapReg(A2));

  UPDATE_ERRNO();
  free(path1);
  return picode->next;
}

/* sys_obreak */

OP(aint_brk)
{
  process_ptr pprocess = pthread->pprocess;

  MapReg(RET_VAL_REG) = 0;
  MapReg(ERRNO_REG) = 0;
  /* use brk-1 so that we just extend the current data segment, 
   * rather than adding a new one. -Jamey 6/19/96
   */
  pprocess->add_segment(pprocess->brk-1,
		      MapReg(A0)-pprocess->brk+1,
		      PROT_READ|PROT_WRITE,
		      MAP_PRIVATE);
  pprocess->brk = MapReg(A0);
  return picode->next;
}

OP(aint_getfsstat);

OP(aint_lseek)
{

  int vfd, pfd;

  vfd = MapReg(A0);
  pfd = pthread->pprocess->fd[vfd];

  if (pfd > 2) {
    MapReg(RET_VAL_REG) = lseek(pfd, MapReg(A1), MapReg(A2));
  } else {
    MapReg(RET_VAL_REG) = lseek(pfd, 0, SEEK_CUR);
  }
  
  MapReg(ERRNO_REG) = 0;
  /* printf("aint_lseek: lseeking %d offset %d from %d\n", MapReg(A0), 
	 MapReg(A1), MapReg(A2)); */
  return picode->next;
}

OP(aint_getpid)
{
  MapReg(RET_VAL_REG) = pthread->pprocess->pid;
  MapReg(ERRNO_REG) = 0;
  return(picode->next);
}

OP(aint_mount);
OP(aint_unmount);

OP(aint_setuid)
{
  MapReg(RET_VAL_REG) = setuid(MapReg(A0));
  UPDATE_ERRNO();
  return(picode->next);
}

OP(aint_getuid)
{
  MapReg(RET_VAL_REG) = getuid();
  MapReg(ERRNO_REG) = 0;
  return(picode->next);
}

OP(aint_exec_with_loader);
OP(aint_ptrace);

OP(aint_recvmsg);
OP(aint_sendmsg);
OP(aint_recvfrom);
OP(aint_accept);
OP(aint_getpeername);
OP(aint_getsockname);

OP(aint_access) {
  process_ptr pprocess = pthread->pprocess;
  ulong upath = MapReg(A0);
  int access_mode = MapReg(A1);
  int status;
  char *path = pprocess->strdup_from_object_space(upath);

  informative("access(%s, %d)\n" << path << access_mode);
  status = access(path, access_mode);

  if (status != 0) {
    MapReg(ERRNO_REG) = errno;
    MapReg(RET_VAL_REG) = -1;
  } else {
    MapReg(ERRNO_REG) = 0;
    MapReg(RET_VAL_REG) = 0;
  }
  free(path);
  return (picode->next);
}

OP(aint_chflags);
OP(aint_fchflags);
OP(aint_sync);
OP(aint_kill);
OP(aint_setpgid);

OP(aint_dup)
{
  process_ptr pprocess = pthread->pprocess;
  int vfd, new_vfd;

  vfd = MapReg(A0);

  /* Search for an unused fd */
  for (new_vfd = 0; new_vfd < MAX_FDNUM; new_vfd++)
    if (pprocess->fd[new_vfd] == -1) break;

  if (new_vfd < MAX_FDNUM) {
    pprocess->fd[new_vfd] = pprocess->fd[vfd];
    /* should clear close-on-exec flag of new_vfd */
    MapReg(RET_VAL_REG) = new_vfd;
    MapReg(ERRNO_REG) = 0;
  } else {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = 0;
  }
  return picode->next;
}
 
OP(aint_pipe);
OP(aint_set_program_attributes);
OP(aint_profil);

OP(aint_open)
{
  process_ptr pprocess = pthread->pprocess;
  int pfd, vfd;

  /* Search for an unused fd */
  for (vfd = 0; vfd < MAX_FDNUM; vfd++)
    if (pthread->pprocess->fd[vfd] == -1) break;

  if (vfd < MAX_FDNUM) {
    char *path = pprocess->strdup_from_object_space(MapReg(A0));
    informative("open " << path << endl);
    pfd = open(path, MapReg(A1), MapReg(A2));
    pthread->pprocess->fd[vfd] = pfd;
    
    if (pfd == -1) {
      MapReg(ERRNO_REG) = errno; 
      MapReg(RET_VAL_REG) = -1;
    } else {
      MapReg(ERRNO_REG) = 0;
      MapReg(RET_VAL_REG) = vfd;
    }
    free(path);
  } else {
    MapReg(ERRNO_REG) = ENOMEM;
    MapReg(RET_VAL_REG) = -1;
  }
  return picode->next;
}

OP(aint_getgid)
{
  MapReg(RET_VAL_REG) = getgid();
  MapReg(ERRNO_REG) = 0;
  return(picode->next);
}

OP(aint_sigprocmask)
{
  int how = MapReg(A0);
  sigset_t set = MapReg(A1);
  sigset_t oset;

  sigprocmask(how, &set, &oset);

  // MapReg(RET_VAL_REG) = oset;
  MapReg(RET_VAL_REG) = set;

  return(picode->next);
}

OP(aint_getlogin);
OP(aint_setlogin);
OP(aint_acct);
OP(aint_sigpending);

OP(aint_ioctl)
{
  // extern int ioctl(int d, int request, void * arg );

  /* The fd is in a0, the command in a1, and the output buf in a2 */
  char mybuf[255];
  int vfd, pfd, len;
  process_ptr pprocess = pthread->pprocess;

  vfd = MapReg(A0);
  pfd = pthread->pprocess->fd[vfd];

  len = (MapReg(A1) >> 16) & 0x1fff;

  if ((MapReg(A1)>> 28) & 0x2) {
    /* memcpy(mybuf, (char *) (long) PMAP(MapReg(A2)), len); */
    pprocess->memcpy_from_object_space(mybuf, MapReg(A2), len);

  }

  MapReg(RET_VAL_REG) = ioctl(pfd, MapReg(A1), mybuf);

  if (MapReg(RET_VAL_REG) < 0) {
      MapReg(ERRNO_REG) = errno; 
      /* printf("aint_ioctl: errno %d\n", errno); */
  } else MapReg(ERRNO_REG) = 0;

  /* if out parameter, then fill in the results */
  if ( (MapReg(A1)>>28) && 0x4) {
    /* memcpy((char *)(long)PMAP(MapReg(A2)), mybuf, len); */
    pprocess->memcpy_to_object_space(MapReg(A2), mybuf, len);
  }
  
  return(picode->next);

}

OP(aint_reboot);
OP(aint_revoke);

OP(aint_symlink)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  char *path2 = pprocess->strdup_from_object_space(MapReg(A1));
  MapReg(RET_VAL_REG) = symlink(path1, path2);

  UPDATE_ERRNO();
  free(path1);
  free(path2);
  return picode->next;
}

OP(aint_readlink)
{
  process_ptr pprocess = pthread->pprocess;
  char *path1 = pprocess->strdup_from_object_space(MapReg(A0));
  char buffer[BUFSIZ];
  MapReg(RET_VAL_REG) = readlink(path1, buffer, BUFSIZ);

  UPDATE_ERRNO();

  if (!MapReg(RET_VAL_REG)) {
    if (strlen(buffer) < MapReg(A2)) {
      pprocess->strcpy_to_object_space(MapReg(A1), buffer);
    } else {
      MapReg(RET_VAL_REG) = -1;
      MapReg(ERRNO_REG) = ERANGE;
    }
  }
  free(path1);
  return picode->next;
}

OP(aint_execve);

OP(aint_umask)
{
  MapReg(RET_VAL_REG) = umask(MapReg(A0));
  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_chroot);

OP(aint_getpgrp);

OP(aint_getpagesize)
{
  MapReg(RET_VAL_REG) = getpagesize();
  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_mremap);
OP(aint_vfork);


OP(aint_stat)
{
  process_ptr pprocess = pthread->pprocess;
  char filename[256];
  unsigned char *statbuf = (unsigned char *) malloc(sizeof(struct stat));

  /* Copy filename */
  pprocess->strcpy_from_object_space(filename, MapReg(A0));

  MapReg(RET_VAL_REG) = stat(filename, (struct stat *) statbuf);

  /* Copy struct stat */
  pprocess->memcpy_to_object_space(MapReg(A1), statbuf, sizeof(struct stat));
  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_stat(\"%s\", [%lx,%lx])\n",
	    pprocess->pid, pthread->tid, filename, 
	    MapReg(A1), MapReg(A1)+sizeof(struct stat));

  MapReg(ERRNO_REG) = MapReg(RET_VAL_REG) ? errno : 0;

  free( (void *) statbuf);

  return picode->next;
}

OP(aint_lstat)
{
  process_ptr pprocess = pthread->pprocess;
  char filename[256];
  unsigned char *statbuf = (unsigned char *) malloc(sizeof(struct stat));

  /* Copy filename */
  pprocess->strcpy_from_object_space(filename, MapReg(A0));

  MapReg(RET_VAL_REG) = lstat(filename, (struct stat *) statbuf);

  /* Copy struct stat */
  pprocess->memcpy_to_object_space(MapReg(A1), statbuf, sizeof(struct stat));
  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_lstat(\"%s\", [%lx,%lx])\n",
	    pprocess->pid, pthread->tid, filename, 
	    MapReg(A1), MapReg(A1)+sizeof(struct stat));

  MapReg(ERRNO_REG) = MapReg(RET_VAL_REG) ? errno : 0;

  free( (void *) statbuf);

  return picode->next;
}

OP(aint_sbrk);
OP(aint_sstk);

OP(aint_mmap)
{
  process_ptr pprocess = pthread->pprocess;
  ulong vaddr = MapReg(A0);
  ulong len = MapReg(A1);
  ulong prot = MapReg(A2);
  ulong flags = MapReg(A3);
  ulong vfd = MapReg(A4);
  ulong offset = MapReg(A5);
  int pfd;
  void *paddr;
  int shmid;
  long thread_errno;

  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_mmap(0x%lx, %ld, prot=0x%lx, flags=0x%lx, %ld/%d, off=0x%lx)\n",
	    pprocess->pid, pthread->tid, 
	    vaddr, len, prot, flags, vfd, pthread->pprocess->fd[vfd], offset);

  if (   ((vaddr & (TB_PAGESIZE-1)) != 0)
      || ((prot & ~(PROT_READ|PROT_WRITE|PROT_EXEC|PROT_NONE)) != 0)
      || ((flags & ~(MAP_FILE|MAP_ANONYMOUS|MAP_VARIABLE|MAP_FIXED|MAP_SHARED|MAP_PRIVATE)) != 0)
      ) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = EINVAL;
    if (Verbose)
      fprintf(stderr, "\t mmap() => EINVAL vaddr/prot/flags \n");
    return picode->next;
  }
  if ((int) vfd < 0 || vfd >= MAX_FDNUM) {
    pfd = -1;
  } else {
    pfd = pprocess->fd[vfd];
    if (pfd == -1) {
      MapReg(RET_VAL_REG) = -1;
      MapReg(ERRNO_REG) = EBADF;
      if (Verbose)
	fprintf(stderr, "\t mmap() => EBADF fd \n");
      return picode->next;
    }
  }
  if ((flags & MAP_ANONYMOUS) && (pfd != -1)) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = EINVAL;
    if (Verbose)
      fprintf(stderr, "\t mmap() => EBADF flags/pfd \n");
    return picode->next;
  }
  paddr = mmap(NULL, len, prot, flags, pfd, offset);
  if (paddr == (void*)-1) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = errno;
    if (Verbose)
      fprintf(stderr, "\t mmap() => errno %d from mmap \n", errno);
    return picode->next;
  }
  /* we use the shmseg structure so that tlb_miss() will fill in the TB entries for mmap()'ed pages */
  shmid = shmseg_allocate(0, len, 0, &thread_errno);
  informative("\t mmap() => " << shmid << "from shmseg_allocate" << endl);
  if (shmid == -1) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = thread_errno;
    if (Verbose)
      fprintf(stderr, "\t mmap() => %ld from shmseg_allocate \n", thread_errno);
    return picode->next;
  }
  Shmseg[shmid].paddr = paddr;
  vaddr = shmseg_attach(pprocess, shmid, vaddr, flags, (ulong *)&thread_errno);
  if (vaddr == -1ul) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = thread_errno;
    if (Verbose)
      fprintf(stderr, "\t mmap() => %ld from shmseg_attach \n", thread_errno);
    return picode->next;
  } else {
    MapReg(RET_VAL_REG) = vaddr;
    MapReg(ERRNO_REG) = 0;
  }
  if (Verbose) {
    long *buf = (long *)paddr;
    uint i;
    for (i = 0; i < sizeof(buf); i += sizeof(long))
      fprintf(stderr, "  buf[%d] = 0x%016lx\n", i, buf[i]);
    
  }
  /* may have to decode new text upon close */
  if (   (prot&PROT_WRITE) == 0
      && vfd != -1ul
      && (flags&MAP_ANONYMOUS) == 0) {
    textregion[pprocess->pid][vfd].startaddr = vaddr;
    textregion[pprocess->pid][vfd].len = len;
  }
  return picode->next;
}

OP(aint_munmap)
{
  warning("AINT_MUNMAP: implemented as no-op" << endl);
  MapReg(RET_VAL_REG) = 0;
  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_madvise)
{
  /* no functionality in OSF1 */
  MapReg(RET_VAL_REG) = 0;
  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_fstat)
{
  process_ptr pprocess = pthread->pprocess;
  int vfd, pfd;
  unsigned char *statbuf = (unsigned char *) malloc(sizeof(struct stat));

  vfd = MapReg(A0);
  pfd = pthread->pprocess->fd[vfd];

  MapReg(RET_VAL_REG) = fstat(pfd, (struct stat *) statbuf);

/* Copy struct stat */
  pprocess->memcpy_to_object_space(MapReg(A1), statbuf, sizeof(struct stat));
  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_fstat(%d/%d, [%lx,%lx])\n",
	    pprocess->pid, pthread->tid, vfd, pfd, 
	    MapReg(A1), MapReg(A1)+sizeof(struct stat));

  MapReg(ERRNO_REG) = 0;

  free( (void *) statbuf);

  return picode->next;
}

OP(aint_fcntl)
{
  process_ptr pprocess = pthread->pprocess;
  int vfd = MapReg(A0);
  int request = MapReg(A1);
  ulong arg = MapReg(A2);
  int pfd;
  int status;
  char *request_name = NULL;

  if ((vfd < 0) || (vfd >= MAX_FDNUM) || ((pfd = pprocess->fd[vfd]) == -1)) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = EBADF;
    return picode->next;
  }

  switch (request) {
  case F_GETLK: 
    request_name = "F_GETLK";
  case F_SETLK:
    request_name = (request_name ? request_name : "F_SETLK");
  case F_SETLKW: {
    struct flock flock_buf;
    request_name = (request_name ? request_name : "F_SETLKW");
    
    pprocess->memcpy_from_object_space((char*)&flock_buf, arg, sizeof(struct flock));
    status = fcntl(pfd, request, &flock_buf);
    if (status != -1)
      pprocess->memcpy_to_object_space(arg, (char*)&flock_buf, sizeof(struct flock));

  } break;
  default:
    request_name = "??";
    status = fcntl(pfd, request, arg);
  }
  MapReg(RET_VAL_REG) = status;
  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_fcntl(%d/%d, %d:%s, [%lx,%lx])\n",
	    pprocess->pid, pthread->tid, vfd, pfd, request, request_name,
	    arg, arg+sizeof(struct flock));

  if (status == -1) {
    MapReg(ERRNO_REG) = errno;
  } else {
    MapReg(ERRNO_REG) = 0;
  }
  return picode->next;
}

OP(aint_truncate)
{
  process_ptr pprocess = pthread->pprocess;
  char *path = pprocess->strdup_from_object_space(MapReg(A0));
  off_t length = MapReg(A1);

  MapReg(RET_VAL_REG) = truncate(path, length);
  if (MapReg(RET_VAL_REG)) 
    MapReg(ERRNO_REG) = errno;
  else
    MapReg(ERRNO_REG) = 0;

  free(path);
  return picode->next;
}

OP(aint_ftruncate)
{
  int vfd = MapReg(A0);
  off_t length = MapReg(A1);

  if (vfd < 0 || vfd >= MAX_FDNUM) {
    MapReg(ERRNO_REG) = EBADF;
    MapReg(RET_VAL_REG) = -1;
    return picode->next;
  }

  MapReg(RET_VAL_REG) = ftruncate(pthread->pprocess->fd[vfd], length);
  if (MapReg(RET_VAL_REG)) 
    MapReg(ERRNO_REG) = errno;
  else
    MapReg(ERRNO_REG) = 0;

  return picode->next;
}

OP(aint_gettimeofday)
{
  process_ptr pprocess = pthread->pprocess;
  struct timeval tval;
  struct timezone tzone;

  MapReg(RET_VAL_REG) = gettimeofday(&tval, &tzone);

  /* Copy the timeval and timezone structs */
  pprocess->memcpy_to_object_space(MapReg(A0), (char*)&tval, sizeof(struct timeval));

  if ( MapReg(A1) != 0 ) {
    unsigned long p_a1 = MapReg(A1);
    pprocess->memcpy_to_object_space(p_a1, (char*)&tzone, sizeof(struct timezone));
  }

  if (MapReg(RET_VAL_REG)) MapReg(ERRNO_REG) = errno;
  else MapReg(ERRNO_REG) = 0;

  return picode->next;
}

OP(aint_getrlimit)
{
  process_ptr pprocess = pthread->pprocess;
  int resource = MapReg(A0);
  struct rlimit rl;
  if (resource == RLIMIT_NOFILE) {
    MapReg(RET_VAL_REG) = 0;
    MapReg(ERRNO_REG) = 0;
    rl.rlim_cur = MAX_FDNUM;
    rl.rlim_max = MAX_FDNUM;
    pprocess->memcpy_to_object_space(MapReg(A1), (char*)&rl, sizeof(struct rlimit));
  } else {
    int status = getrlimit(resource, &rl);
    MapReg(RET_VAL_REG) = status;
    if (!status) {
      MapReg(ERRNO_REG) = 0;
      pprocess->memcpy_to_object_space(MapReg(A1), (char*)&rl, sizeof(struct rlimit));
    } else {
      MapReg(ERRNO_REG) = errno;
    }
  }
  return picode->next;
}

OP(aint_setrlimit)
{
  process_ptr pprocess = pthread->pprocess;
  int resource = MapReg(A0);
  struct rlimit rl;
  pprocess->memcpy_from_object_space((char*)&rl, MapReg(A1), sizeof(struct rlimit));
  if (resource == RLIMIT_NOFILE) {
    if (rl.rlim_max > MAX_FDNUM) {
      MapReg(RET_VAL_REG) = -1;
      MapReg(ERRNO_REG) = EPERM;
    } else if (rl.rlim_cur > rl.rlim_max) {
      MapReg(RET_VAL_REG) = -1;
      MapReg(ERRNO_REG) = EINVAL;
    } else {
      MapReg(RET_VAL_REG) = 0;
      MapReg(ERRNO_REG) = 0;
    }
  } else {
    int status = setrlimit(resource, &rl);
    MapReg(RET_VAL_REG) = status;
    if (!status) {
      MapReg(ERRNO_REG) = 0;
    } else {
      MapReg(ERRNO_REG) = errno;
    }
  }
  return picode->next;
}

OP(aint_sigaction)
{
  process_ptr pprocess = pthread->pprocess;
  int signal = MapReg(A0);
  if (   signal >= 0
      && signal <= SIGUSR2
      && signal != SIGKILL
      && signal != SIGSTOP
      && signal != SIGCONT) {
    struct sigaction action;
    struct sigaction oaction;
    pprocess->memcpy_from_object_space((char*)&action, MapReg(A1), sizeof(action));
    oaction.sa_handler = (void (*)(int)) pprocess->sigv[signal].sv_handler;
    oaction.sa_mask =pprocess->sigv[signal].sv_mask;
    oaction.sa_flags =pprocess->sigv[signal].sv_flags;

   pprocess->sigv[signal].sv_handler = (void (*)(int, ...))action.sa_handler;
   pprocess->sigv[signal].sv_mask = action.sa_mask;
   pprocess->sigv[signal].sv_flags = action.sa_flags;

    if (MapReg(A2))
      pprocess->memcpy_to_object_space(MapReg(A2), (char*)&oaction, sizeof(oaction));

    MapReg(RET_VAL_REG) = 0;
    MapReg(ERRNO_REG) = 0;
  } else {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = EINVAL;
  }
  return picode->next;
}


// extern int getdirentries(int fd, char *buf, int nbytes, long *basep );

OP(aint_getdirentries)
{
  process_ptr pprocess = pthread->pprocess;
  ulong vfd = MapReg(A0);
  ulong object_buf = MapReg(A1);
  ulong nbytes = MapReg(A2);
  ulong object_basep = MapReg(A3);
  int pfd;
  char *buf = (char *) malloc(nbytes);
  long basep;
  int status;

  if (buf == NULL)
    fatal("aint_getdirentries failed to allocate " << nbytes << " bytes" << endl);

  if ((vfd < 0) || (vfd >= MAX_FDNUM) || ((pfd = pprocess->fd[vfd]) == -1)) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = EBADF;
    return picode->next;
  }
  status = getdirentries(pfd, buf, nbytes, &basep);
  MapReg(RET_VAL_REG) = status;
  if (status != -1) {
    MapReg(ERRNO_REG) = 0;
    pprocess->memcpy_to_object_space(object_buf, (void*)buf, nbytes);
    *(long *)pprocess->addr2phys(object_basep, NULL) = basep;
  } else {
    MapReg(ERRNO_REG) = errno;
  }
  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_getdirentries(%ld/%d, [%lx,%lx], %ld, %lx)\n",
	   pprocess->pid, pthread->tid, vfd, pfd, 
	    object_buf, object_buf+nbytes, nbytes,
	    object_basep);

  free(buf);

  return picode->next;
}


// extern int statfs(char *path, struct statfs *buffer, int length );
// extern int fstatfs(int file_descriptor, struct statfs *buffer, int length );

OP(aint_statfs)
{
#ifdef FIXME
  process_ptr pprocess = pthread->pprocess;
  char *path;
  ulong path_ptr = MapReg(A0);
  ulong object_buf = MapReg(A1);
  ulong length = MapReg(A2);
  struct statfs aint_buf;
  int status;

  path = pprocess->strdup_from_object_space(path_ptr);

  status = statfs(path, &aint_buf, sizeof(struct statfs));

  MapReg(RET_VAL_REG) = status;
  UPDATE_ERRNO();

  if (!status) {
    pprocess->memcpy_to_object_space(object_buf, (char*)&aint_buf,  sizeof(struct statfs));
  }
  if (Verbose)
    fprintf(stderr, "[p%d.t%d] \t aint_statfs(\"%s\", [%lx,%lx], %ld)\n",
	   pprocess->pid, pthread->tid, path, 
	    object_buf, object_buf+sizeof(struct statfs),
	    length);

  free(path);
#endif
  return picode->next;
}

OP(aint_fstatfs)
{
#ifdef FIXME
  process_ptr pprocess = pthread->pprocess;
  int vfd = MapReg(A0);
  ulong object_buf = MapReg(A1);
  struct statfs aint_buf;
  int status;
  int pfd;

  if ((vfd < 0) || (vfd >= MAX_FDNUM) || ((pfd =pprocess->fd[vfd]) == -1)) {
    MapReg(RET_VAL_REG) = -1;
    MapReg(ERRNO_REG) = EBADF;
    return picode->next;
  }

  status = fstatfs(pfd, &aint_buf, sizeof(struct statfs));

  MapReg(RET_VAL_REG) = status;
  UPDATE_ERRNO();

  if (!status) {
    pprocess->memcpy_to_object_space(object_buf, (char*)&aint_buf, sizeof(struct statfs));
  }
#endif
  return picode->next;
}


OP(aint_getdtablesize)
{
  MapReg(RET_VAL_REG) = MAX_FDNUM;
  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_getrusage)
{
  process_ptr pprocess = pthread->pprocess;
  struct rusage mybuf;

  MapReg(RET_VAL_REG) = getrusage(MapReg(A0), &mybuf);

  /* Copy the struct rusage */
  pprocess->memcpy_to_object_space(MapReg(A1), (char*)&mybuf, sizeof(mybuf));

  MapReg(ERRNO_REG) = 0;
  return picode->next;
}

OP(aint_uswitch)
{
#ifdef FIXME
  extern long uswitch (long cmd, long mask);
  process_ptr pprocess = pthread->pprocess;

  long cmd = MapReg(A0);
  long mask = MapReg(A1);
  long result = 0;

  if ((mask & ~USW_NULLP) == 0) {
    segment_t *null_seg = pprocess->find_segment(0);

    if (cmd == USC_SET) {
      if (mask & USW_NULLP) {
	pprocess->add_segment(0, 1, PROT_READ, MAP_PRIVATE);
      } else {
	/* disable null pointer references */
	if (null_seg)
	  null_seg->prot &= ~(PROT_READ|PROT_WRITE);
      }
      result = mask;
    } else {
      if (null_seg && (null_seg->prot & PROT_READ))
	result |= USW_NULLP;
    }

    MapReg(RET_VAL_REG) = result;
    MapReg(ERRNO_REG) = 0;

  } else {
    warning("USWITCH: " << (void *) cmd << " " << (void *) mask << " -- please report" << endl);
    MapReg(RET_VAL_REG) = uswitch(cmd, mask);
    MapReg(ERRNO_REG) = (MapReg(RET_VAL_REG) == -1) ? errno : 0;
  }
#endif
  return picode->next;
}


OP(aint_usleep_thread)
{
  pthread->runstate = R_SLEEP;
  MapReg(ERRNO_REG) = 0;
  return(picode->next);
}

extern int set_speculative(void *, long, long, long, long);
OP(aint_set_speculative)
{
  ulong vm_offset = MapReg(A0);
  ulong size = MapReg(A1);
  ulong segv_action = MapReg(A2);
  ulong fpe_action = MapReg(A3);
  ulong version = MapReg(A4);
  
  MapReg(RET_VAL_REG) = 0;

  if (version != 1) {
    MapReg(ERRNO_REG) = EINVAL;
  } else if (!((long)segv_action >= 0 || segv_action <= 2)) {
    MapReg(ERRNO_REG) = EINVAL;
  } else if (!((long) fpe_action >= 0 || fpe_action <= 2)) {
    MapReg(ERRNO_REG) = EINVAL;
  } else {
    informative("SET_SPECULATIVE: " << (void *) vm_offset
		<< " " << (void *) size
		<< " " << segv_action
		<< " " << fpe_action
		<< " " << version
		<< " -- please report." << endl);

    MapReg(ERRNO_REG) = 0;
  }
  return picode->next;
}

OP(aint_getsysinfo)
{
  ulong op = MapReg(A0);
  ulong buffer = MapReg(A1);
  ulong nbytes = MapReg(A2);
  ulong start = MapReg(A3);
  ulong arg = MapReg(A4);

  char *buf = (char *) malloc(nbytes);

  MapReg(0) = getsysinfo(op,
			 buf,
			 nbytes,
			 (start ? (int *) pthread->pprocess->PMAP(start) : 0),
			 (arg ? (void *) pthread->pprocess->PMAP(arg) : 0));

  if (MapReg(RET_VAL_REG) != 0) {
    MapReg(ERRNO_REG) = errno;
  } else {
    MapReg(ERRNO_REG) = 0;
    if (buffer)
      pthread->pprocess->memcpy_to_object_space(buffer, buf, nbytes);
  }
  free (buf);

  return(picode->next);
}

OP(aint_setsysinfo)
{
  ulong op = MapReg(A0);
  ulong buffer = MapReg(A1);
  ulong nbytes = MapReg(A2);
  ulong start = MapReg(A3);
  ulong arg = MapReg(A4);
  ulong flag = MapReg(A5);
  ulong retval = 0;
  ulong errval = 0;

  switch (op) {
  case SSI_NVPAIRS: {
    /* nbytes is actually nelts, for int elts -Jamey, 7/15/96 */
    int npairs = nbytes;
    int bufsize = npairs*2*sizeof(int);
    int *buf = (int*)malloc(bufsize);
    int i;

    pthread->pprocess->memcpy_from_object_space((char*)buf, buffer, bufsize);
    for (i = 0; i < npairs; i++) {
      int op = buf[2*i];
      switch(op) {
      case SSIN_UACPROC: /* set unaligned access processing on/off */
	{
	  int buf[2];
	  int rc = setsysinfo(SSI_NVPAIRS, buf, sizeof(buf), 0);
	  // cerr << "\t SSIN_UACPROC rc=" << rc << " errno=" << (rc?errno:0) << endl;
	}
	break;
      default:
	warning("Encountered name=" << op << " in setsysinfo(SSI_NVPAIRS, ...)" << endl);
	break;
      }
    }
    free(buf);
  } break;
  case SSI_IEEE_FP_CONTROL: {
    long buf;
    double fpcr = *(double*)&ifi->fpcr;

    asm ("trapb; mt_fpcr %0; trapb"
	 : : "f" (fpcr));

    informative("setsysinfo: SSI_IEEE_FP_CONTROL -- fpcr was " << (void *) *(ulong*)&fpcr << endl);

    pthread->pprocess->memcpy_from_object_space((char*)&buf, buffer, 
			     sizeof(buf));
    retval = setsysinfo(SSI_IEEE_FP_CONTROL, &buf, sizeof(buf), start, arg, flag);
    if (!retval)
      errval = errno;

    informative("setsysinfo: SSI_IEEE_FP_CONTROL -- set IEEE_FP_CONTROL set to " << (void *) buf << endl);

    {
      /* testing */
      getsysinfo(GSI_IEEE_FP_CONTROL, (char*)&buf, sizeof(buf), 0, 0, 0);
      informative("setsysinfo: GSI_IEEE_FP_CONTROL -- IEEE_FP_CONTROL is " << (void *) buf << endl);
    }

    asm ("trapb; mf_fpcr %0; trapb"
	 : "=f" (fpcr));

    ifi->fpcr |= *(ulong*)&fpcr;
    if (ifi->fpcr & FPCR_UNDZ)
      ifi->fpcr |= FPCR_UNFD;

    informative("setsysinfo: SSI_IEEE_FP_CONTROL -- fpcr now " << (void *) *(ulong*)&fpcr << endl);
  } break;
  default: {
    warning("Encountered op=" << op << " in setsysinfo(" << op << ", ...)" << endl);
  }
  }

  MapReg(RET_VAL_REG) = retval;
  MapReg(ERRNO_REG) = errval;

  return(picode->next);
}

OP(aint_pthread_create)
{
  process_ptr pprocess = pthread->pprocess;
  thread_ptr childt;
  ulong arg_pthread_ptr, arg_attr_ptr, arg_func_ptr, arg_arg;
  int tid;

  arg_pthread_ptr = MapReg(A0);
  arg_attr_ptr = MapReg(A1);
  arg_func_ptr = MapReg(A2);
  arg_arg = MapReg(A3);

  aint_addr_t start_pc = arg_func_ptr;

  /* allocate a new thread as child of the current one */
  childt = new thread(pthread, start_pc);


  /* the first instruction for the child is the start routine */
  childt->picode = pprocess->addr2iphys(start_pc, NULL);
    
  /* the return value for the parent is 0 */
  MapReg(RET_VAL_REG) = 0;
  MapReg(ERRNO_REG) = 0;
  
  /* the return value for the child doesn't matter */
  childt->path_tree->pMapReg(RET_VAL_REG) = 0;
  childt->path_tree->pMapReg(ERRNO_REG) = 0;

  /* Pass the correct procedure value */
  childt->path_tree->pMapReg(PROCEDURE_VALUE_REG) = childt->picode->addr;

  /* the start routine's only argument is our A3 */
  childt->path_tree->pMapReg(A0) = arg_arg;

  /* Assign the correct thread structure to the pthread_t argument. */
  * (thread_ptr *) pprocess->addr2phys(arg_pthread_ptr, NULL) = childt;
  /* This is probably the only place where the object space contains a pointer
     value valid in AINT space */


  // childt->sigblocked = pthread->sigblocked;

  // This routine is called from thread::thread()
  // sim_thread_begin(childt->tid, childt->picode->addr);

  return picode->next;

  
}



/* FIXME: For pthread_join to work correctly for programs where threads
 * may wait for another thread *after* it's dead, we should avoid
 * re-use of threads and tid's
 */
OP(aint_pthread_join)
{

  thread_ptr jthread;    // Joinee thread
  process_ptr pprocess = pthread->pprocess;

  /* Look at the state of the joinee. If it's done, detach it and return */
  jthread = (thread_ptr) MapReg(A0);

  if (jthread->runstate == R_DONE) {

      MapReg(RET_VAL_REG) = 0;
      MapReg(ERRNO_REG) = 0;
      * (void **) (pprocess->addr2phys(MapReg(A1), NULL)) = (void *) jthread->path_tree->pMapReg(A0);

      return (picode->next);
  }

  jthread->Waiting_Threads.dll_enqueue( (void *)pthread);

  /* block thread */
  sim_thread_block(pthread->tid);
  pthread->runstate = R_WAIT;
  // must try this same function again...
  return picode;

}


OP(aint_pthread_exit)
{

  pthread->exitcode = MapReg(A0);

  while ( !(pthread->Waiting_Threads.is_empty()) ) {
    /* Wakeup waiting threads */
    thread_ptr wthread = (thread_ptr) pthread->Waiting_Threads.dll_dequeue();
    sim_thread_unblock(wthread->tid);
  }
  pthread->runstate = R_DONE;
  if (pthread->pprocess->thread_count == 1) pthread->pprocess->runstate = R_DONE;

  sim_thread_end(pthread->tid);

  return NULL;
}


OP(aint_pthread_keycreate)
{
  process_ptr pprocess = pthread->pprocess;
  int retval;
  unsigned long key_vaddr, key_paddr;

  retval = pprocess->pthread_keys_in_use;

  /* Find the first free key */
  if (retval == AINT_pthread_keys_max) {
    /* No more keys */
    MapReg(RET_VAL_REG) = EAGAIN;
    MapReg(ERRNO_REG) = 0;
    return(picode->next);
  }

  /* There are more keys available */
  pprocess->pthread_keys_in_use++;

  key_vaddr = MapReg(A0);
  key_paddr = (ulong) pprocess->addr2phys(key_vaddr, NULL);
  * (unsigned int *) key_paddr = retval;

  MapReg(RET_VAL_REG) = 0;
  MapReg(ERRNO_REG) = 0;

  /* Ignore the destructor */
  return(picode->next);
  
}


OP(aint_pthread_setspecific)
{
  process_ptr pprocess = pthread->pprocess;
  unsigned int tsd_key;

  tsd_key = MapReg(A0);

  /* Is the key valid? */
  if (tsd_key >= pprocess->pthread_keys_in_use) {
    MapReg(RET_VAL_REG) = EINVAL;
    MapReg(ERRNO_REG) = 0;
    return picode->next;
  }

  /* Set this thread's TSD for this key to value */
  pthread->TSD[tsd_key] = MapReg(A1);

  MapReg(RET_VAL_REG) = 0;
  MapReg(ERRNO_REG) = 0;

  return picode->next;
}
  

OP(aint_pthread_getspecific)
{
  process_ptr pprocess = pthread->pprocess;
  unsigned int tsd_key;

  tsd_key = MapReg(A0);

  if (tsd_key >= pprocess->pthread_keys_in_use) {
    MapReg(RET_VAL_REG) = 0;
  } else {
    MapReg(RET_VAL_REG) = pthread->TSD[tsd_key];
  }
  
  MapReg(ERRNO_REG) = 0;

  return picode->next;
}


OP(aint_pthread_self)
{
  MapReg(RET_VAL_REG) = (long) pthread;
  MapReg(ERRNO_REG) = 0;

  return picode->next;
}




const char *syscall_name(int syscall)
{
  switch (syscall) {
  case SYS_syscall: return "SYS_syscall"; break;
  case SYS_exit: return "SYS_exit"; break;
  case SYS_fork: return "SYS_fork"; break;
  case SYS_read: return "SYS_read"; break;
  case SYS_write: return "SYS_write"; break;
  case SYS_old_open: return "SYS_old_open"; break;
  case SYS_close: return "SYS_close"; break;
  case SYS_wait4: return "SYS_wait4"; break;
  case SYS_old_creat: return "SYS_old_creat"; break;
  case SYS_link: return "SYS_link"; break;
  case SYS_unlink: return "SYS_unlink"; break;
  case SYS_execv: return "SYS_execv"; break;
  case SYS_chdir: return "SYS_chdir"; break;
  case SYS_fchdir: return "SYS_fchdir"; break;
  case SYS_mknod: return "SYS_mknod"; break;
  case SYS_chmod: return "SYS_chmod"; break;
  case SYS_chown: return "SYS_chown"; break;
  case SYS_obreak: return "SYS_obreak"; break;
  case SYS_getfsstat: return "SYS_getfsstat"; break;
  case SYS_lseek: return "SYS_lseek"; break;
  case SYS_getpid: return "SYS_getpid"; break;
  case SYS_mount: return "SYS_mount"; break;
  case SYS_unmount: return "SYS_unmount"; break;
  case SYS_setuid: return "SYS_setuid"; break;
  case SYS_getuid: return "SYS_getuid"; break;
  case SYS_exec_with_loader: return "SYS_exec_with_loader"; break;
  case SYS_ptrace: return "SYS_ptrace"; break;
#ifdef	COMPAT_43
  case SYS_nrecvmsg: return "SYS_nrecvmsg"; break;
  case SYS_nsendmsg: return "SYS_nsendmsg"; break;
  case SYS_nrecvfrom: return "SYS_nrecvfrom"; break;
  case SYS_naccept: return "SYS_naccept"; break;
  case SYS_ngetpeername: return "SYS_ngetpeername"; break;
  case SYS_ngetsockname: return "SYS_ngetsockname"; break;
#else
  case SYS_recvmsg: return "SYS_recvmsg"; break;
  case SYS_sendmsg: return "SYS_sendmsg"; break;
  case SYS_recvfrom: return "SYS_recvfrom"; break;
  case SYS_accept: return "SYS_accept"; break;
  case SYS_getpeername: return "SYS_getpeername"; break;
  case SYS_getsockname: return "SYS_getsockname"; break;
#endif
  case SYS_access: return "SYS_access"; break;
  case SYS_chflags: return "SYS_chflags"; break;
  case SYS_fchflags: return "SYS_fchflags"; break;
  case SYS_sync: return "SYS_sync"; break;
  case SYS_kill: return "SYS_kill"; break;
  case SYS_old_stat: return "SYS_old_stat"; break;
  case SYS_setpgid: return "SYS_setpgid"; break;
  case SYS_old_lstat: return "SYS_old_lstat"; break;
  case SYS_dup: return "SYS_dup"; break;
  case SYS_pipe: return "SYS_pipe"; break;
  case SYS_set_program_attributes: return "SYS_set_program_attributes"; break;
  case SYS_profil: return "SYS_profil"; break;
  case SYS_open: return "SYS_open"; break;
  case SYS_getgid: return "SYS_getgid"; break;
  case SYS_sigprocmask: return "SYS_sigprocmask"; break;
  case SYS_getlogin: return "SYS_getlogin"; break;
  case SYS_setlogin: return "SYS_setlogin"; break;
  case SYS_acct: return "SYS_acct"; break;
  case SYS_sigpending: return "SYS_sigpending"; break;
  case SYS_ioctl: return "SYS_ioctl"; break;
  case SYS_reboot: return "SYS_reboot"; break;
  case SYS_revoke: return "SYS_revoke"; break;
  case SYS_symlink: return "SYS_symlink"; break;
  case SYS_readlink: return "SYS_readlink"; break;
  case SYS_execve: return "SYS_execve"; break;
  case SYS_umask: return "SYS_umask"; break;
  case SYS_chroot: return "SYS_chroot"; break;
  case SYS_old_fstat: return "SYS_old_fstat"; break;
  case SYS_getpgrp: return "SYS_getpgrp"; break;
  case SYS_getpagesize: return "SYS_getpagesize"; break;
  case SYS_mremap: return "SYS_mremap"; break;
  case SYS_vfork: return "SYS_vfork"; break;
  case SYS_stat: return "SYS_stat"; break;
  case SYS_lstat: return "SYS_lstat"; break;
  case SYS_sbrk: return "SYS_sbrk"; break;
  case SYS_sstk: return "SYS_sstk"; break;
  case SYS_mmap: return "SYS_mmap"; break;
  case SYS_ovadvise: return "SYS_ovadvise"; break;
  case SYS_munmap: return "SYS_munmap"; break;
  case SYS_mprotect: return "SYS_mprotect"; break;
  case SYS_madvise: return "SYS_madvise"; break;
  case SYS_old_vhangup: return "SYS_old_vhangup"; break;
  case SYS_kmodcall: return "SYS_kmodcall"; break;
  case SYS_mincore: return "SYS_mincore"; break;
  case SYS_getgroups: return "SYS_getgroups"; break;
  case SYS_setgroups: return "SYS_setgroups"; break;
  case SYS_old_getpgrp: return "SYS_old_getpgrp"; break;
  case SYS_setpgrp: return "SYS_setpgrp"; break;
  case SYS_setitimer: return "SYS_setitimer"; break;
  case SYS_old_wait: return "SYS_old_wait"; break;
  case SYS_table: return "SYS_table"; break;
  case SYS_getitimer: return "SYS_getitimer"; break;
  case SYS_gethostname: return "SYS_gethostname"; break;
  case SYS_sethostname: return "SYS_sethostname"; break;
  case SYS_getdtablesize: return "SYS_getdtablesize"; break;
  case SYS_dup2: return "SYS_dup2"; break;
  case SYS_fstat: return "SYS_fstat"; break;
  case SYS_fcntl: return "SYS_fcntl"; break;
  case SYS_select: return "SYS_select"; break;
  case SYS_poll: return "SYS_poll"; break;
  case SYS_fsync: return "SYS_fsync"; break;
  case SYS_setpriority: return "SYS_setpriority"; break;
  case SYS_socket: return "SYS_socket"; break;
  case SYS_connect: return "SYS_connect"; break;
#ifdef	COMPAT_43
  case SYS_accept: return "SYS_accept"; break;
#else
  case SYS_old_accept: return "SYS_old_accept"; break;
#endif
  case SYS_getpriority: return "SYS_getpriority"; break;
#ifdef	COMPAT_43
  case SYS_send: return "SYS_send"; break;
  case SYS_recv: return "SYS_recv"; break;
#else
  case SYS_old_send: return "SYS_old_send"; break;
  case SYS_old_recv: return "SYS_old_recv"; break;
#endif
  case SYS_sigreturn: return "SYS_sigreturn"; break;
  case SYS_bind: return "SYS_bind"; break;
  case SYS_setsockopt: return "SYS_setsockopt"; break;
  case SYS_listen: return "SYS_listen"; break;
  case SYS_plock: return "SYS_plock"; break;
  case SYS_old_sigvec: return "SYS_old_sigvec"; break;
  case SYS_old_sigblock: return "SYS_old_sigblock"; break;
  case SYS_old_sigsetmask: return "SYS_old_sigsetmask"; break;
  case SYS_sigsuspend: return "SYS_sigsuspend"; break;
  case SYS_sigstack: return "SYS_sigstack"; break;
#ifdef	COMPAT_43
  case SYS_recvmsg: return "SYS_recvmsg"; break;
  case SYS_sendmsg: return "SYS_sendmsg"; break;
#else
  case SYS_old_recvmsg: return "SYS_old_recvmsg"; break;
  case SYS_old_sendmsg: return "SYS_old_sendmsg"; break;
#endif
    /* 115 is obsolete vtrace */
  case SYS_gettimeofday: return "SYS_gettimeofday"; break;
  case SYS_getrusage: return "SYS_getrusage"; break;
  case SYS_getsockopt: return "SYS_getsockopt"; break;
  case SYS_readv: return "SYS_readv"; break;
  case SYS_writev: return "SYS_writev"; break;
  case SYS_settimeofday: return "SYS_settimeofday"; break;
  case SYS_fchown: return "SYS_fchown"; break;
  case SYS_fchmod: return "SYS_fchmod"; break;
#ifdef	COMPAT_43
  case SYS_recvfrom: return "SYS_recvfrom"; break;
#else
  case SYS_old_recvfrom: return "SYS_old_recvfrom"; break;
#endif
  case SYS_setreuid: return "SYS_setreuid"; break;
  case SYS_setregid: return "SYS_setregid"; break;
  case SYS_rename: return "SYS_rename"; break;
  case SYS_truncate: return "SYS_truncate"; break;
  case SYS_ftruncate: return "SYS_ftruncate"; break;
  case SYS_flock: return "SYS_flock"; break;
  case SYS_setgid: return "SYS_setgid"; break;
  case SYS_sendto: return "SYS_sendto"; break;
  case SYS_shutdown: return "SYS_shutdown"; break;
  case SYS_socketpair: return "SYS_socketpair"; break;
  case SYS_mkdir: return "SYS_mkdir"; break;
  case SYS_rmdir: return "SYS_rmdir"; break;
  case SYS_utimes: return "SYS_utimes"; break;
    /* 139 is obsolete 4.2 sigreturn */
  case SYS_adjtime: return "SYS_adjtime"; break;
#ifdef	COMPAT_43
  case SYS_getpeername: return "SYS_getpeername"; break;
#else
  case SYS_old_getpeername: return "SYS_old_getpeername"; break;
#endif
  case SYS_gethostid: return "SYS_gethostid"; break;
  case SYS_sethostid: return "SYS_sethostid"; break;
  case SYS_getrlimit: return "SYS_getrlimit"; break;
  case SYS_setrlimit: return "SYS_setrlimit"; break;
  case SYS_old_killpg: return "SYS_old_killpg"; break;
  case SYS_setsid: return "SYS_setsid"; break;
  case SYS_quotactl: return "SYS_quotactl"; break;
  case SYS_oldquota: return "SYS_oldquota"; break;
#ifdef	COMPAT_43
  case SYS_getsockname: return "SYS_getsockname"; break;
#else
  case SYS_old_getsockname: return "SYS_old_getsockname"; break;
#endif
  case SYS_pid_block: return "SYS_pid_block"; break;
  case SYS_pid_unblock: return "SYS_pid_unblock"; break;
  case SYS_sigaction: return "SYS_sigaction"; break;
  case SYS_sigwaitprim: return "SYS_sigwaitprim"; break;
  case SYS_nfssvc: return "SYS_nfssvc"; break;
  case SYS_getdirentries: return "SYS_getdirentries"; break;
  case SYS_statfs: return "SYS_statfs"; break;
  case SYS_fstatfs: return "SYS_fstatfs"; break;
  case SYS_async_daemon: return "SYS_async_daemon"; break;
  case SYS_getfh: return "SYS_getfh"; break;
  case SYS_getdomainname: return "SYS_getdomainname"; break;
  case SYS_setdomainname: return "SYS_setdomainname"; break;
  case SYS_exportfs: return "SYS_exportfs"; break;
  case SYS_alt_plock: return "SYS_alt_plock"; break;
  case SYS_getmnt: return "SYS_getmnt"; break;
  case SYS_alt_sigpending: return "SYS_alt_sigpending"; break;
  case SYS_alt_setsid: return "SYS_alt_setsid"; break;
  case SYS_swapon: return "SYS_swapon"; break;
  case SYS_msgctl: return "SYS_msgctl"; break;
  case SYS_msgget: return "SYS_msgget"; break;
  case SYS_msgrcv: return "SYS_msgrcv"; break;
  case SYS_msgsnd: return "SYS_msgsnd"; break;
  case SYS_semctl: return "SYS_semctl"; break;
  case SYS_semget: return "SYS_semget"; break;
  case SYS_semop: return "SYS_semop"; break;
  case SYS_uname: return "SYS_uname"; break;
  case SYS_lchown: return "SYS_lchown"; break;
  case SYS_shmat: return "SYS_shmat"; break;
  case SYS_shmctl: return "SYS_shmctl"; break;
  case SYS_shmdt: return "SYS_shmdt"; break;
  case SYS_shmget: return "SYS_shmget"; break;
  case SYS_mvalid: return "SYS_mvalid"; break;
  case SYS_getaddressconf: return "SYS_getaddressconf"; break;
  case SYS_msleep: return "SYS_msleep"; break;
  case SYS_mwakeup: return "SYS_mwakeup"; break;
  case SYS_msync: return "SYS_msync"; break;
  case SYS_signal: return "SYS_signal"; break;
  case SYS_utc_gettime: return "SYS_utc_gettime"; break;
  case SYS_utc_adjtime: return "SYS_utc_adjtime"; break;
  case SYS_security: return "SYS_security"; break;
  case SYS_kloadcall: return "SYS_kloadcall"; break;
  case SYS_getpgid: return "SYS_getpgid"; break;
  case SYS_getsid: return "SYS_getsid"; break;
  case SYS_sigaltstack: return "SYS_sigaltstack"; break;
  case SYS_waitid: return "SYS_waitid"; break;
  case SYS_priocntlset: return "SYS_priocntlset"; break;
  case SYS_sigsendset: return "SYS_sigsendset"; break;
  case SYS_set_speculative: return "SYS_set_speculative"; break;
  case SYS_msfs_syscall: return "SYS_msfs_syscall"; break;
  case SYS_sysinfo: return "SYS_sysinfo"; break;
  case SYS_uadmin: return "SYS_uadmin"; break;
  case SYS_fuser: return "SYS_fuser"; break;
  case SYS_proplist_syscall: return "SYS_proplist_syscall"; break;
  case SYS_uswitch: return "SYS_uswitch"; break;
  case SYS_usleep_thread: return "SYS_usleep_thread"; break;
  case SYS_audcntl: return "SYS_audcntl"; break;
  case SYS_audgen: return "SYS_audgen"; break;
  case SYS_sysfs: return "SYS_sysfs"; break;
  case SYS_subsys_info: return "SYS_subsys_info"; break;
  case SYS_getsysinfo: return "SYS_getsysinfo"; break;
  case SYS_setsysinfo: return "SYS_setsysinfo"; break;
  case SYS_afs_syscall: return "SYS_afs_syscall"; break;
  case SYS_swapctl: return "SYS_swapctl"; break;
  case SYS_memcntl: return "SYS_memcntl"; break;
  default: return "??"; break;
  }
}
